## 统一异常处理
　　`ai.yue.library.base.config.handler.ExceptionHandlerConfig` 全局统一异常处理配置，将拦截 Controller 层抛出的所有异常进行统一处理并响应相应的提示（包括 Restful 风格的异常提示）

### API 请求路径
![API 请求路径](统一异常处理_files/1.png)

### 配置项
```yml
yue:
  exception-handler:
    enabled: true # 默认开启统一异常处理
```

### 示例
**代码示例：**
```java
@PostMapping("/exception")
public Result<?> exception() {
	throw new ParamException("异常测试");
}
```

**响应结果：**
```json
{
    "code": 433,
    "msg": "参数校验未通过，请参照API核对后重试",
    "flag": false,
    "data": "异常测试"
}
```

**控制台内容：**
```java
ai.yue.library.base.exception.ParamException: 异常测试
	at ai.yue.library.template.simple.controller.doc.example.ExceptionController.exception(ExceptionController.java:25)
	at ai.yue.library.template.simple.controller.doc.example.ExceptionController$$FastClassBySpringCGLIB$$17435ec5.invoke(<generated>:-1)
	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)
	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:750)
2020-02-10 22:21:09.986  WARN 33636 --- [nio-8080-exec-1] .m.m.a.ExceptionHandlerExceptionResolver : Resolved [ai.yue.library.base.exception.ParamException: 异常测试]
```