## 架构升级
　　yue-library默认依赖微服务组件SpringCloud，后续也可以很好的对项目就行架构升级。而项目的前期，如果在没有必要的情况下，建议大家基于yue-library提供的SpringBoot功能做好相关规划，进行快速的开发迭代，在后续需要架构升级时，再进行拆分服务。

## 编码风格
　　yue-library的设计规范符合 [Java开发手册](https://gitee.com/yl-yue/yue-library/raw/master/docs/_media/Java开发手册_v1.5.0_华山版.pdf)<br>
　　STS（eclipse）JAVA代码模版：[点击下载](https://gitee.com/yl-yue/yue-library/raw/master/docs/_media/STS配置.epf)
> 导入eclipse即可：Import -> preferences -> 选择文件 -> Finish <br>

## 版本
yue-library的版本命名方式，采用SpringCloud版本名作为前缀，然后以.1、.2、.3...这种形式，目的是为了方便区分基础依赖版本。<br>

|JDK版本|JDK说明												|SpringCloud版本|版本说明																			|
|--		|--														|--				|--																					|
|JDK8	|LTS（Oracle长期支持版本），目前大部分互联网公司采用版本|Finchley		|JDK8兼容版本，每次新特性发布都会进行一次全面的兼容适配与测试，以供JDK8用户稳定使用	|
|JDK11	|LTS（Oracle长期支持版本），作者采用版本				|Greenwich		|JDK11推荐版本，提供更快速的迭代与反馈												|

## 开源库推荐（技术栈）
### 分布式架构
|技术栈					|作者使用方案																								|其他推荐方案						|
|--						|--																											|--									|
|分布式部署				|[Rancher](https://blog.csdn.net/u013600314/article/details/80484102)										|									|
|devops					|阿里云云效 + [yue-open-devops-deploy](https://gitee.com/yl-yue/yue-open/tree/master/yue-open-devops-deploy)|rancher、gitlab ci/cd、jenkins		|
|分布式事务				|Seata																										|LCN								|
|分布式调度中心			|xxl-job																									|									|
|分布式存储				|minio、阿里云oss																							|ceph、fastDFS、hadoop-HDFS、HBase	|
|前端环境变量部署、IDE	|HBuilder X + nginx																							|									|

### 后端
　　本库定义了多个开源项目依赖版本，可以直接引入使用。这些开源库也是经过作者千挑万选的，绝对值得一试。
- hutool JDK工具包 项目中默认只引入了hutool工具包的核心模块`hutool-core`，也就是工具类。此外hutool还提供了如：系统`hutool-system`、脚本`hutool-script`、扩展`hutool-extra`、切面`hutool-aop`等模块
- pay-java-parent 支付工具包 包括：支付宝、微信、银联、跨境支付paypal
- easypoi office工具包 包括：word、excel
- jpush 极光推送

### 前端
#### PC
- vue
- vue-element-ui
- vue-element-admin

#### APP
- uni-app

## ylyue宣言
　　开源共建，不忘初心，奋斗前行。

　　此项目将永久开源免费，只要作者还继续JAVA编程，生活又过得去，项目便会不断迭代升级。

　　同时编程是我的爱好，技术追求是我的兴趣。愿所有编程人员，热爱工作、努力奋斗、憧憬未来。