# 数据库设计与交付规约v1
## 数据库设计规约
　　请遵守[《阿里巴巴Java开发手册》](https://gitee.com/yl-yue/yue-library/raw/master/docs/_media/Java开发手册_v1.5.0_华山版.pdf)数据库设计规约，并确保整体设计风格的一致性。<br>
　　表的设计需符合业务逻辑需求，同时应最大程度上的降低 <font color=red>开发、维护、扩展</font> 成本，并允许拥有一部分合理范围之内的设计模式与理念。

特殊类型规约补充：

|类型	|说明																																|
|--		|--																																	|
|枚举	|禁止使用1,2,3...代表状态，请使用具体枚举值，某些情况下使用中文好过蹩脚英语。若状态拥有流转过程，请在注释中详细说明（如：订单状态）	|
|布尔	|同开发手册，必须使用 is_xxx 的方式命名，数据类型是 unsigned tinyint 1位（1 表示是，0 表示否）										|

命名规约强调与补充：

|场景	|说明																																					|
|--		|--																																						|
|库命名	|库名与应用（服务）名称尽量一致，同时只允许采用下划线“_”分割，字符集统一使用`utf8mb4`。																|
|表命名	|表的命名最好是加上“业务名称_表的作用”（如：`user_info / user_config / pay_order / pay_config`），数据记录表应只用于新增查询统计，不可执行修改操作。	|

## 交付评审规约
- 文档说明，优雅的概括本次变动与自己的设计思路
- 表的位置（链接地址 - 数据库）
- 变更字段的位置
- 完善的表注释与字段注释
- 规范的字段命名，关联字段保持统一风格（不规范的字段命名改动，需提出并获得评审通过）
- 删除表需特别说明 并 <font color=red>加以强调</font>

### 新增表
- 详细概括表的作用与设计思路
- 提供全表DDL
- 表中的约束与索引
- 表与表之间的关系（禁止使用外键）

### 更改表
- 字段变更的说明
- 提供全表DDL
- 本次改动DDL
- 表中的约束与索引

## 维护规约
　　数据库设计并非一蹴而就，开发中发现不合理与遗漏的表设计，需对其进行修改时，必须对其所有变更进行DDL记录与变更说明。<br>
　　项目上线或发布时，数据库同步便可参照本次变更记录做对比，考虑是否有数据结构安全隐患，以作数据的处理。规则如下：
- 每次变动记录详细的变动DLL语句并解释此次变更是为什么
- 变更前先明确表设计初衷，后续为何变更，初衷是否改变，是否需要更新表初衷