# 规约
yue-library已提供 [Restful](https://ylyue.cn/#/base/Restful) 支持

## 为什么要有编码规范
> <font color=red>黄金定律：</font><br>
> 永远遵循同一套编码规范 -- 不管有多少人共同参与同一项目，一定要确保每一行代码都像是同一个人编写的。

### 一、编码规范对于团队合作的重要性
　　1、几乎没有任何一个软件，在其整个生命周期中，均由最初的开发人员来维护<br>
　　2、如果没有统一的代码规范，那么每个人的代码必定会风格迥异，在多个人同时开发同一模块的情况，整合代码将无从下手。<br>
　　3、大多数情况下，并非程序中有复杂的算法或是复杂的逻辑，而是去读别人的代码实在是一件痛苦的事情。统一的风格使得代码可读性大大提高了，人们看到任何一段代码都会觉得异常熟悉。显然的，规范的代码在团队的合作开发中是非常有益而且必要的。

### 二、编码规范给个人带来的好处
　　1、长期的规范性编码，可以给开发人员养成良好的编码习惯，甚至锻炼出更加严谨的逻辑思维；<br>
　　2、编码规范，在软件构件以及项目管理中，甚至是个人成长方面，都发挥着重要的作用，好的编码规范是提高我们代码质量的最有效的工具之一。<br>
　　3、遵守编码规范，最大的收益人是自己。复杂的算法可以体现个人的逻辑能力，但绝不代表个人的开发水平。规范的代码更有利于帮助你理解开发语言理解模式理解架构，能够帮助你快速提升开发水平。不明白这点，即使写出再高明的算法，在别人眼里也只是一堆乱码一样的存在。养成良好的开发习惯是绝对必需的。不要沉迷表面的得失，看似无用的东西要经过慢慢的累积由量变达到质变的时候，你才能感受到其价值所在。一些开源项目，一些大师级人物写得程序都是极其规范的。<br>
　　4、没有规范的对输入输出参数处理，没有规范的异常处理，没有规范的日志处理等等，不但导致了我们总是出现类似空指针这样低级的bug而且还很难找到引起bug的原因。相反，在规范的开发中，bug不但可以有效减少，查找bug也变得轻而易举。规范不是对开发的制约，而确实是有助于提高开发效率的。

### 三、编码规范给团队带来的好处
　　1、维护他人代码，就像维护自己的一样轻松。<br>
　　2、自我对代码的审查及时纠正一些错误，团队的代码审查同时也是一个很好的学习机会，对成员的进步也是很有益的<br>
　　3、项目经理对团队代码的检阅也将变成可能。<br>
　　4、随着我们项目经验的累积，会越来越重视后期维护的成本。而开发过程中的代码质量直接影响着维护的成本。维护工作不仅仅是读懂原有代码，而是需要在原有代码基础上作出修改。<br>
　　5、如果没有统一风格的情况下，A完成开发以后，B进行维护加一段代码，过一段时间C又加一段代码。。。。。。直到有一天X看到那一大堆乱码想死的心都有了，维护也就进行不下去了。
    
> “任何一个傻瓜都能写出计算机可以理解的代码，唯有写出人类容易理解的代码，才是优秀的程序员。” 

## 后端编码规范
　　服务端编码规范尤为重要，好的编码习惯不光能减少BUG的产生，更能严谨开发人员的逻辑思维，从而减少一些不必要的损失。

- [Java开发手册](https://gitee.com/yl-yue/yue-library/raw/master/docs/_media/Java开发手册_v1.5.0_华山版.pdf)
- [后端规约说明](规约/后端规约说明.md#后端规约说明)
- [STS（eclipse）JAVA代码模版](https://gitee.com/yl-yue/yue-library/raw/master/docs/_media/STS配置.epf)

> 导入eclipse即可：Import -> preferences -> 选择文件 -> Finish